#include <wann/ANN.h>
#include <iostream>

#define N   3
#define DIM 2
#define K   1

using namespace std;

int main ()
{
	ANNpointArray dataPts;
	ANNdistArray  dataWeights;
	ANNpoint      q;
	ANNidxArray   nnIdx;
	ANNdistArray  costs;
	ANNkd_tree*   kdTree;

	q           = annAllocPt(DIM);
	dataPts     = annAllocPts(N, DIM);
	dataWeights = annAllocWeights(N);
	nnIdx       = new ANNidx[K];
	costs       = new ANNdist[K];

	dataPts[0][0] = -1.; dataPts[0][1] =  0.;
	dataPts[1][0] =  1.; dataPts[1][1] = -1.;
	dataPts[2][0] =  1.; dataPts[2][1] =  1.;
	dataWeights[0] = dataWeights[1] = dataWeights[2] = 0.;

	kdTree = new ANNkd_tree(dataPts, dataWeights, N, DIM);

	q[0] = q[1] = 0.;

	kdTree->annkSearch(q, K, nnIdx, costs, 0.);

	cout << "Nearest neighbor: (";
	cout << dataPts[nnIdx[0]][0] << ", ";
	cout << dataPts[nnIdx[0]][1] << "); squared dist = ";
	cout << costs[0] << "\n";

	kdTree->setWeight(0, 2.);

	kdTree->annkSearch(q, 1, nnIdx, costs, 0.);

	cout << "Weighted nearest neighbor: (";
	cout << dataPts[nnIdx[0]][0] << ", ";
	cout << dataPts[nnIdx[0]][1] << "); squared dist = ";
	cout << costs[0] - dataWeights[nnIdx[0]] << "\n";

	annDeallocPt(q);
	annDeallocPts(dataPts);
	annDeallocWeights(dataWeights);
	delete [] nnIdx;
	delete [] costs;
	delete kdTree;
	annClose();

	return 0;
}
